#include "AWError.h"
#include <stdlib.h>
#include <string.h>

__thread AW_errno AW_errnum;

struct AW_strerror
{
    const char* name;
    const char* desc;
};

#define AW_STRERROR_GEN(n, s) {"AW_" #n, s},
static struct AW_strerror AW_strerror_tab[] = {AW_ERRNO_MAP(AW_STRERROR_GEN)};
#undef AW_STRERROR_GEN

const char* AW_ERR_name(AW_errno errnum)
{
    return AW_strerror_tab[errnum].name;
}

const char* AW_ERR_desc(AW_errno errnum)
{

    if (errnum == AW_ERR_SYS)
        return strerror(errno);
    else
        return AW_strerror_tab[errnum].desc;
}
